package de.jottyfan.quickiemod.item;

import java.util.ArrayList;
import java.util.List;

import de.jottyfan.quickiemod.Quickiemod;
import de.jottyfan.quickiemod.identifier.ModIdentifiers;
import net.minecraft.item.Item;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.util.Identifier;

/**
 *
 * @author jotty
 *
 */
public class ModItems {
	public static final Item ITEM_STUB = registerItem(ModIdentifiers.ITEM_STUB,
			new Item64Stack(ModIdentifiers.ITEM_STUB));
	public static final Item ITEM_SPEEDPOWDER = registerItem(ModIdentifiers.ITEM_SPEEDPOWDER,
			new Item64Stack(ModIdentifiers.ITEM_SPEEDPOWDER));
	public static final Item ITEM_QUICKIEPOWDER = registerItem(ModIdentifiers.ITEM_QUICKIEPOWDER,
			new Item64Stack(ModIdentifiers.ITEM_QUICKIEPOWDER));
	public static final Item ITEM_SALPETER = registerItem(ModIdentifiers.ITEM_SALPETER,
			new Item64Stack(ModIdentifiers.ITEM_SALPETER));
	public static final Item ITEM_SULFOR = registerItem(ModIdentifiers.ITEM_SULFOR,
			new Item64Stack(ModIdentifiers.ITEM_SULFOR));
	public static final Item ITEM_OXIDIZEDCOPPERPOWDER = registerItem(ModIdentifiers.ITEM_OXIDIZEDCOPPERPOWDER,
			new Item64Stack(ModIdentifiers.ITEM_OXIDIZEDCOPPERPOWDER));
	public static final Item ITEM_SPEEDINGOT = registerItem(ModIdentifiers.ITEM_SPEEDINGOT,
			new Item64Stack(ModIdentifiers.ITEM_SPEEDINGOT));
	public static final Item ITEM_QUICKIEINGOT = registerItem(ModIdentifiers.ITEM_QUICKIEINGOT,
			new Item64Stack(ModIdentifiers.ITEM_QUICKIEINGOT));
	public static final Item ITEM_CARROTSTACK = registerItem(ModIdentifiers.ITEM_CARROTSTACK,
			new Item64Stack(ModIdentifiers.ITEM_CARROTSTACK));
	public static final Item ITEM_ROTTENFLESHSTRIPES = registerItem(ModIdentifiers.ITEM_ROTTENFLESHSTRIPES,
			new Item64Stack(ModIdentifiers.ITEM_ROTTENFLESHSTRIPES));
	public static final Item ITEM_COTTON = registerItem(ModIdentifiers.ITEM_COTTON,
			new Item64Stack(ModIdentifiers.ITEM_COTTON));
	public static final Item ITEM_COTTONPLANT = registerItem(ModIdentifiers.ITEM_COTTONPLANT,
			new Item64Stack(ModIdentifiers.BLOCK_COTTONPLANT));
	public static final Item ITEM_COTTONSEED = registerItem(ModIdentifiers.ITEM_COTTONSEED,
			new ItemSeed(ModIdentifiers.ITEM_COTTONSEED, ModIdentifiers.BLOCK_COTTONPLANT));
	public static final Item ITEM_CANOLA = registerItem(ModIdentifiers.ITEM_CANOLA,
			new Item64Stack(ModIdentifiers.ITEM_CANOLA));
	public static final Item ITEM_CANOLAPLANT = registerItem(ModIdentifiers.ITEM_CANOLAPLANT,
			new Item64Stack(ModIdentifiers.BLOCK_CANOLAPLANT));
	public static final Item ITEM_CANOLASEED = registerItem(ModIdentifiers.ITEM_CANOLASEED,
			new ItemSeed(ModIdentifiers.ITEM_CANOLASEED, ModIdentifiers.BLOCK_CANOLAPLANT));
	public static final Item ITEM_CANOLABOTTLE = registerItem(ModIdentifiers.ITEM_CANOLABOTTLE,
			new Item64Stack(ModIdentifiers.ITEM_CANOLABOTTLE));
	public static final Item ITEM_CANOLABOTTLESTACK = registerItem(ModIdentifiers.ITEM_CANOLABOTTLESTACK,
			new Item64Stack(ModIdentifiers.ITEM_CANOLABOTTLESTACK));

	public static final Item TOOL_SPEEDPOWDERAXE = registerItem(ModIdentifiers.TOOL_SPEEDPOWDERAXE,
			new ToolSpeedpowderAxe(ModIdentifiers.TOOL_SPEEDPOWDERAXE));
	public static final Item TOOL_SPEEDPOWDERHOE = registerItem(ModIdentifiers.TOOL_SPEEDPOWDERHOE,
			new ToolSpeedpowderHoe(ModIdentifiers.TOOL_SPEEDPOWDERHOE));
	public static final Item TOOL_SPEEDPOWDERPICKAXE = registerItem(ModIdentifiers.TOOL_SPEEDPOWDERPICKAXE,
			new ToolSpeedpowderPickaxe(ModIdentifiers.TOOL_SPEEDPOWDERPICKAXE));
	public static final Item TOOL_SPEEDPOWDERSHEARS = registerItem(ModIdentifiers.TOOL_SPEEDPOWDERSHEARS,
			new ToolSpeedpowderShears(ModIdentifiers.TOOL_SPEEDPOWDERSHEARS));
	public static final Item TOOL_SPEEDPOWDERSHOVEL = registerItem(ModIdentifiers.TOOL_SPEEDPOWDERSHOVEL,
			new ToolSpeedpowderShovel(ModIdentifiers.TOOL_SPEEDPOWDERSHOVEL));
	public static final Item TOOL_SPEEDPOWDERWATERHOE = registerItem(ModIdentifiers.TOOL_SPEEDPOWDERWATERHOE,
			new ToolSpeedpowderWaterHoe(ModIdentifiers.TOOL_SPEEDPOWDERWATERHOE));
	public static final Item TOOL_QUICKIEPOWDERAXE = registerItem(ModIdentifiers.TOOL_QUICKIEPOWDERAXE,
			new ToolQuickiepowderAxe(ModIdentifiers.TOOL_QUICKIEPOWDERAXE));
	public static final Item TOOL_QUICKIEPOWDERHOE = registerItem(ModIdentifiers.TOOL_QUICKIEPOWDERHOE,
			new ToolQuickiepowderHoe(ModIdentifiers.TOOL_QUICKIEPOWDERHOE));
	public static final Item TOOL_QUICKIEPOWDERPICKAXE = registerItem(ModIdentifiers.TOOL_QUICKIEPOWDERPICKAXE,
			new ToolQuickiepowderPickaxe(ModIdentifiers.TOOL_QUICKIEPOWDERPICKAXE));
	public static final Item TOOL_QUICKIEPOWDERSHOVEL = registerItem(ModIdentifiers.TOOL_QUICKIEPOWDERSHOVEL,
			new ToolQuickiepowderShovel(ModIdentifiers.TOOL_QUICKIEPOWDERSHOVEL));
	public static final Item TOOL_QUICKIEPOWDERWATERHOE = registerItem(ModIdentifiers.TOOL_QUICKIEPOWDERWATERHOE,
			new ToolQuickiepowderWaterHoe(ModIdentifiers.TOOL_QUICKIEPOWDERWATERHOE));

	private static final Item registerItem(Identifier identifier, Item item) {
		return Registry.register(Registries.ITEM, identifier, item);
	}

	public static final List<Item> registerModItems() {
		Quickiemod.LOGGER.debug(String.format("registering item %s", Quickiemod.MOD_ID));

		List<Item> items = new ArrayList<>();
		items.add(ITEM_STUB);
		items.add(ITEM_SPEEDPOWDER);
		items.add(ITEM_QUICKIEPOWDER);
		items.add(ITEM_SALPETER);
		items.add(ITEM_SULFOR);
		items.add(ITEM_OXIDIZEDCOPPERPOWDER);
		items.add(ITEM_SPEEDINGOT);
		items.add(ITEM_QUICKIEINGOT);
		items.add(ITEM_CARROTSTACK);
		items.add(ITEM_ROTTENFLESHSTRIPES);
		items.add(ITEM_COTTON);
		items.add(ITEM_COTTONSEED);
		items.add(ITEM_CANOLA);
		items.add(ITEM_CANOLASEED);
		items.add(ITEM_CANOLABOTTLE);
		items.add(ITEM_CANOLABOTTLESTACK);

		items.add(TOOL_SPEEDPOWDERPICKAXE);
		items.add(TOOL_SPEEDPOWDERAXE);
		items.add(TOOL_SPEEDPOWDERSHOVEL);
		items.add(TOOL_SPEEDPOWDERHOE);
		items.add(TOOL_SPEEDPOWDERWATERHOE);
		items.add(TOOL_SPEEDPOWDERSHEARS);
		items.add(TOOL_QUICKIEPOWDERPICKAXE);
		items.add(TOOL_QUICKIEPOWDERAXE);
		items.add(TOOL_QUICKIEPOWDERSHOVEL);
		items.add(TOOL_QUICKIEPOWDERHOE);
		items.add(TOOL_QUICKIEPOWDERWATERHOE);
		return items;
	}
}
